=encoding utf8

=head1 NAME

Mail::Box::POP3 - handle POP3 folders as client

=head1 INHERITANCE

 Mail::Box::POP3
   is a Mail::Box::Net
   is a Mail::Box
   is a Mail::Reporter

 Mail::Box::POP3 is extended by
   Mail::Box::POP3s

=head1 SYNOPSIS

  use Mail::Box::POP3;
  my $folder = Mail::Box::POP3->new(folder => $ENV{MAIL}, ...);

=head1 DESCRIPTION

Maintain a folder which has its messages stored on a remote server.  The
communication between the client application and the server is implemented
using the POP3 protocol.  This class uses L<Mail::Transport::POP3|Mail::Transport::POP3> to
hide the transport of information, and focusses solely on the correct
handling of messages within a POP3 folder.

B<Be aware:>
This module versions 4.0 and up is not fully compatible with older releases:
mainly the exception handling has changed.  When you need to upgrade, please
read F<https://github.com/markov2/perl5-Mail-Box/wiki/>
B<Version 3 is still maintained> and may see new releases as well.

Extends L<"DESCRIPTION" in Mail::Box::Net|Mail::Box::Net/"DESCRIPTION">.

=head1 OVERLOADED

Extends L<"OVERLOADED" in Mail::Box::Net|Mail::Box::Net/"OVERLOADED">.

=over 4

=item overload: B<'""'> stringification

Inherited, see L<Mail::Box/"OVERLOADED">

=item overload: B<'@{}'> use as ARRAY

Inherited, see L<Mail::Box/"OVERLOADED">

=item overload: B<cmp> string comparison

Inherited, see L<Mail::Box/"OVERLOADED">

=back

=head1 METHODS

Extends L<"METHODS" in Mail::Box::Net|Mail::Box::Net/"METHODS">.

=head2 Constructors

Extends L<"Constructors" in Mail::Box::Net|Mail::Box::Net/"Constructors">.

=over 4

=item $class-E<gt>B<new>(%options)

For authentications, you have three choices: specify a foldername which
resembles an URL, or specify a pop-client object, or separate options
for user, password, pop-server and server-port.
Improves base, see L<Mail::Box/"Constructors">

 -Option           --Defined in     --Default
  access             Mail::Box        'r'
  authenticate                        'AUTO'
  body_delayed_type  Mail::Box        Mail::Message::Body::Delayed
  body_type          Mail::Box        Mail::Message::Body::Lines
  coerce_options     Mail::Box        +[]
  create             Mail::Box        <not applicable>
  extract            Mail::Box        10240
  field_type         Mail::Box        undef
  fix_headers        Mail::Box        false
  folder             Mail::Box        <not applicable>
  folderdir          Mail::Box        <network location>
  head_delayed_type  Mail::Box        Mail::Message::Head::Delayed
  head_type          Mail::Box        Mail::Message::Head::Complete
  keep_dups          Mail::Box        false
  lock_file          Mail::Box        undef
  lock_timeout       Mail::Box        1 hour
  lock_type          Mail::Box        'NONE'
  lock_wait          Mail::Box        10 seconds
  locker             Mail::Box        undef
  manager            Mail::Box        undef
  message_type       Mail::Box        Mail::Box::POP3::Message
  multipart_type     Mail::Box        Mail::Message::Body::Multipart
  password           Mail::Box::Net   undef
  pop_client                          undef
  remove_when_empty  Mail::Box        <false>
  save_on_exit       Mail::Box        true
  server_name        Mail::Box::Net   undef
  server_port        Mail::Box::Net   110
  ssl_options                         undef
  trusted            Mail::Box        <false>
  use_ssl                             false
  username           Mail::Box::Net   undef

=over 2

=item access => $mode

=item authenticate => 'LOGIN'|'APOP'|'AUTO'|'OUATH2'|'OAUTH2_SEP'

POP3 can use two methods of authentication: the old LOGIN protocol, which
transmits a username and password in plain text, and the newer APOP
protocol which uses MD5 encryption.  APOP is therefore much better, however
not always supported by the server.  With AUTO, first APOP is tried and
if that fails LOGIN.

OAUTH* requires the authorization token to be passed as Password.
Microsoft Office365 needs C<OAUTH2_SEP>, where other oauth2
implementations use C<OAUTH2>.

=item body_delayed_type => CLASS

=item body_type => CLASS|CODE

=item coerce_options => ARRAY

=item create => BOOLEAN

=item extract => INTEGER|CODE|METHOD|'LAZY'|'ALWAYS'

=item field_type => $class

=item fix_headers => BOOLEAN

=item folder => $name

=item folderdir => $directory

=item head_delayed_type => $class

=item head_type => $class

=item keep_dups => BOOLEAN

=item lock_file => $file

=item lock_timeout => $seconds

=item lock_type => $class|$name|\@names

=item lock_wait => $seconds

=item locker => $locker

=item manager => $manager

=item message_type => $class

=item multipart_type => CLASS

=item password => $password

=item pop_client => OBJECT

You may want to specify your own pop-client object.  The object
which is passed must extend L<Mail::Transport::POP3|Mail::Transport::POP3>.

=item remove_when_empty => BOOLEAN

=item save_on_exit => BOOLEAN

=item server_name => $host

=item server_port => $number

=item ssl_options => HASH

=item trusted => BOOLEAN

=item use_ssl => BOOLEAN

=item username => $username

=back

» example: 

  my $url = 'pop3://user:password@pop.xs4all.nl'
  my $pop = Mail::Box::POP3->new($url);

  my $pop = $mgr->open(type => 'pop3',
     username => 'myname', password => 'mypassword',
     server_name => 'pop.xs4all.nl'
  );

=back

=head2 Attributes

Extends L<"Attributes" in Mail::Box::Net|Mail::Box::Net/"Attributes">.

=over 4

=item $obj-E<gt>B<fixHeaders>()

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<folderdir>( [$directory] )

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<isTrusted>()

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<name>()

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<removeEmpty>()

Inherited, see L<Mail::Box/"Attributes">

=item $obj-E<gt>B<type>()

Inherited, see L<Mail::Box/"Attributes">

=back

=head2 The folder

Extends L<"The folder" in Mail::Box::Net|Mail::Box::Net/"The folder">.

=over 4

=item $obj-E<gt>B<addMessage>($message)

It is impossible to write messages to the average POP3 server.  There are
extensions to the protocol which do permit it, however these are not
implemented (yet, patches welcome).

C<undef> is returned, and an error displayed.  However, no complaint is
given when the C<$message> is C<undef> itself.
Improves base, see L<Mail::Box/"The folder">

 -Option--Defined in--Default
  share   Mail::Box   <not used>

=over 2

=item share => BOOLEAN

=back

=item $obj-E<gt>B<addMessages>($messages)

As useless as L<addMessage()|Mail::Box::POP3/"METHODS">.  The only acceptable call to this method
is without any message.
Improves base, see L<Mail::Box/"The folder">

=item $class-E<gt>B<appendMessages>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<close>(%options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<copyTo>($folder, %options)

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<delete>(%options)

It is not possible to delete a POP3 folder remotely: the best we can do
is remove all the messages in it... which is the action implemented here.
A notice is logged about this.
Improves base, see L<Mail::Box/"The folder">

 -Option   --Defined in--Default
  recursive  Mail::Box   <not used>

=over 2

=item recursive => BOOLEAN

=back

=item $obj-E<gt>B<organization>()

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<size>()

Inherited, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<update>()

NOT IMPLEMENTED YET
Improves base, see L<Mail::Box/"The folder">

=item $obj-E<gt>B<url>()

Inherited, see L<Mail::Box/"The folder">

=back

=head2 Folder flags

Extends L<"Folder flags" in Mail::Box::Net|Mail::Box::Net/"Folder flags">.

=over 4

=item $obj-E<gt>B<access>()

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<isModified>()

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<modified>( [BOOLEAN] )

Inherited, see L<Mail::Box/"Folder flags">

=item $obj-E<gt>B<writable>()

Inherited, see L<Mail::Box/"Folder flags">

=back

=head2 The messages

Extends L<"The messages" in Mail::Box::Net|Mail::Box::Net/"The messages">.

=over 4

=item $obj-E<gt>B<current>( [$number|$message|$message_id] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<find>($message_id)

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<findFirstLabeled>( $label, [BOOLEAN, [\@msgs]] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<message>( $index, [$message] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messageId>( $message_id, [$message] )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messageIds>()

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<messages>( <'ALL'|$range|'ACTIVE'|'DELETED'|$label| !$label|$filter> )

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<nrMessages>(%options)

Inherited, see L<Mail::Box/"The messages">

=item $obj-E<gt>B<scanForMessages>($message, $message_ids, $timespan, $window)

Inherited, see L<Mail::Box/"The messages">

=back

=head2 Sub-folders

Extends L<"Sub-folders" in Mail::Box::Net|Mail::Box::Net/"Sub-folders">.

=over 4

=item $any-E<gt>B<listSubFolders>(%options)

The standard POP3 protocol does not support sub-folders, so an
empty list will be returned in any case.
Improves base, see L<Mail::Box/"Sub-folders">

 -Option    --Defined in     --Default
  check       Mail::Box        false
  folder      Mail::Box        <from calling object>
  folderdir   Mail::Box        <from folder>
  skip_empty  Mail::Box        false

=over 2

=item check => BOOLEAN

=item folder => $name

=item folderdir => $dir

=item skip_empty => BOOL

=back

=item $any-E<gt>B<nameOfSubFolder>( $subname, [$parentname] )

Inherited, see L<Mail::Box/"Sub-folders">

=item $obj-E<gt>B<openRelatedFolder>(%options)

Inherited, see L<Mail::Box/"Sub-folders">

=item $obj-E<gt>B<openSubFolder>(%options)

It is not possible to open a sub-folder for a POP3 folder, because that
is not supported by the official POP3 protocol. In any case, C<undef>
is returned to indicate a failure.
Improves base, see L<Mail::Box/"Sub-folders">

=item $any-E<gt>B<topFolderWithMessages>()

Inherited, see L<Mail::Box/"Sub-folders">

=back

=head2 Internals

Extends L<"Internals" in Mail::Box::Net|Mail::Box::Net/"Internals">.

=over 4

=item $obj-E<gt>B<coerce>($message, %options)

Inherited, see L<Mail::Box/"Internals">

=item $any-E<gt>B<create>($folder, %options)

It is not possible to create a new folder on a POP3 server.  This method
will always return C<false>.
Improves base, see L<Mail::Box::Net/"METHODS">

 -Option   --Defined in--Default
  folderdir  Mail::Box   undef

=over 2

=item folderdir => $directory

=back

=item $obj-E<gt>B<determineBodyType>($message, $head)

Inherited, see L<Mail::Box/"Internals">

=item $class-E<gt>B<foundIn>( [$foldername], %options )

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<getHead>($message)

Read the header for the specified message from the remote server.

=item $obj-E<gt>B<getHeadAndBody>($message)

Read all data for the specified message from the remote server.

=item $obj-E<gt>B<lineSeparator>( [<STRING|'CR'|'LF'|'CRLF'>] )

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<locker>()

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<popClient>(%options)

Returns the pop client object.  This does not establish the connection.

 -Option     --Default
  ssl_options  <from new(ssl_options)>
  use_ssl      <from new(use_ssl)>

=over 2

=item ssl_options => HASH

=item use_ssl => BOOLEAN

=back

=item $obj-E<gt>B<read>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<readMessages>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<storeMessage>($message)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<toBeThreaded>($messages)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<toBeUnthreaded>($messages)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<updateMessages>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<write>(%options)

Inherited, see L<Mail::Box/"Internals">

=item $obj-E<gt>B<writeMessages>(%options)

Inherited, see L<Mail::Box/"Internals">

 -Option  --Defined in--Default
  messages  Mail::Box   <required>

=over 2

=item messages => ARRAY

=back

=back

=head2 Other methods

Extends L<"Other methods" in Mail::Box::Net|Mail::Box::Net/"Other methods">.

=over 4

=item $any-E<gt>B<timespan2seconds>($time)

Inherited, see L<Mail::Box/"Other methods">

=back

=head2 Error handling

Extends L<"Error handling" in Mail::Box::Net|Mail::Box::Net/"Error handling">.

=over 4

=item $obj-E<gt>B<AUTOLOAD>()

Inherited, see L<Mail::Reporter/"Error handling">

=item $obj-E<gt>B<notImplemented>()

Inherited, see L<Mail::Reporter/"Error handling">

=back

=head2 Cleanup

Extends L<"Cleanup" in Mail::Box::Net|Mail::Box::Net/"Cleanup">.

=over 4

=item $obj-E<gt>B<DESTROY>()

Inherited, see L<Mail::Box/"Cleanup">

=back

=head1 DETAILS

Extends L<"DETAILS" in Mail::Box::Net|Mail::Box::Net/"DETAILS">.

=head2 Different kinds of folders

Extends L<"Different kinds of folders" in Mail::Box::Net|Mail::Box::Net/"Different kinds of folders">.

=head2 Available folder types

Extends L<"Available folder types" in Mail::Box::Net|Mail::Box::Net/"Available folder types">.

=head2 Folder class implementation

Extends L<"Folder class implementation" in Mail::Box::Net|Mail::Box::Net/"Folder class implementation">.

=head2 How POP3 folders work

Rfc1939 defines how POP3 works.  POP3 is a really simple protocol to
receive messages from a server to a user's client.  POP3 is also
really limited: it can only be used to fetch messages, but has not
many ways to limit the amount of network traffic, like the IMAP4
protocol has.

One POP3 account represents only one folder: there is no way of
sub-folders in POP3.  POP3 doesn't support writing (except for
some message status flags).

=head2 This implementation

The protocol specifics are implemented in L<Mail::Transport::POP3|Mail::Transport::POP3>,
written by Liz Mattijsen.  That module does not use any of the
other POP3 modules available on CPAN for the reason that MailBox
tries to be smarter: it is capable of re-establishing broken POP3
connection when the server supports UIDs.

The implementation has shown to work with many different POP servers.
In the test directory of the distribution, you will find a small
server implementation, which is used to test the client.

=head1 DIAGNOSTICS

=over 4

=item Error: Cannot find head back for $id on POP3 server $name.

The server told to have this message, but when asked for its headers, no
single line was returned.  Did the message get destroyed?
Cast by C<getHeadAndBody()>

=item Error: Cannot read body for $id on POP3 server $name.

The message's headers are retrieved from the server, but the body seems
to be lost.  Did the message get destroyed between reading the header
and reading the body?
Cast by C<getHeadAndBody()>

=item Error: Folder $name is opened read-only

You can not write to this folder unless you have opened the folder to
write or append with L<new(access)|Mail::Box/"Constructors">, or the C<force> option is set C<true>.
Cast by C<write()>

=item Warning: Message $id on POP3 server $name disappeared.

The server indicated the existence of this message before, however it
has no information about the message anymore.
Cast by C<getHeadAndBody()>

=item Warning: POP3 folders cannot be deleted.

Each user has only one POP3 folder on a server.  This folder is created and
deleted by the server's administrator only.
Cast by C<delete()>

=item Error: cannot create POP3 client for $name.

The connection to the POP3 server cannot be established.  You may see
more, related, error messages about the failure.
Cast by C<popClient()>

=item Warning: changes not written to read-only folder $name.

You have opened the folder read-only --which is the default set
by L<new(access)|Mail::Box/"Constructors">--, made modifications, and now want to close it.
Set L<close(force)|Mail::Box/"The folder"> if you want to overrule the access mode, or close
the folder with L<close(write)|Mail::Box/"The folder"> set to C<NEVER>.
Cast by C<close()>

=item Error: class $package does not implement method $method.

Fatal error: the specific C<$package> (or one of its superclasses) does not
implement this method where it should. This message means that some other
related classes do implement this method however the class at hand does
not.  Probably you should investigate this and probably inform the author
of the package.
Cast by C<notImplemented()>

=item Error: copying failed for one message.

For some reason, for instance disk full, removed by external process, or
read-protection, it is impossible to copy one of the messages.  Copying will
proceed for the other messages.
Cast by C<copyTo()>

=item Error: destination folder $name is not writable.

The folder where the messages are copied to is not opened with write
access (see L<new(access)|Mail::Box/"Constructors">).  This has no relation with write permission
to the folder which is controlled by your operating system.
Cast by C<copyTo()>

=item Warning: different messages with id $msgid.

The message id is discovered more than once within the same folder, but the
content of the message seems to be different.  This should not be possible:
each message must be unique.
Cast by C<messageId()>

=item Error: invalid timespan '$span'.

The string does not follow the strict rules of the time span syntax which
is permitted as parameter.
Cast by C<timespan2seconds()>

=item Warning: message $id disappeared from POP3 server $name.

Cast by C<getHead()>

=item Warning: message-id '$msgid' does not contain a domain.

According to the RFCs, message-ids need to contain a unique random part,
then an C<@>, and then a domain name.  This is made to avoid the creation
of two messages with the same id.  The warning emerges when the C<@> is
missing from the string.
Cast by C<messageId()>

=item Error: unknown value to folder->close(write => $when).

Cast by C<close()>

=item Warning: update of $count messages ignored for POP3 folder $name.

The standard POP3 implementation does not support writing from client back
to the server.  Therefore, modifications may be lost.
Cast by C<writeMessages()>

=item Error: you cannot write a message to a pop server (yet)

Some extensions to the POP3 protocol do permit writing messages to the server,
but the standard protocol only implements retreival.  Feel invited to extend our
implementation with writing.
Cast by C<addMessage()>

=item Error: you cannot write messages to a pop server (yet)

Cast by C<addMessages()>

=back

=head1 SEE ALSO

This module is part of Mail-Box-POP3 version 4.02,
built on April 10, 2026. Website: F<http://perl.overmeer.net/CPAN/>

=head1 LICENSE

For contributors see file ChangeLog.

This software is copyright (c) 2001-2026 by Mark Overmeer.

This is free software; you can redistribute it and/or modify it under
the same terms as the Perl 5 programming language system itself.

